/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package TestPackage;

import Java2OWL.J2OCompiler;
import Java2OWL.J2OWLClass;
import Java2OWL.J2OWLProperty;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author ohlbach
 */
@J2OWLClass 
public class SimpleStudent {
    
    private String name;
    @J2OWLProperty(name = "hasName", setter="setName")
    public String getName() {return name;}
    public void setName(String name) {this.name = name;}
    
    private int semester;
    @J2OWLProperty(name = "semester", setter="setSemester")
    public int getSemester() {return semester;}
    public void setSemester(int semester) {this.semester = semester;}
    
    @Override
    public String toString() {return this.getClass().getName() + ": " +name;}
    
    public SimpleStudent(){}
    
    public SimpleStudent(String name, int semester) {this.name = name; this.semester = semester;}
    
    @J2OWLClass(EquivalentClass = "semester value 1")
    public static class Freshman extends SimpleStudent {
        @Override
        public int getSemester() {return 1;}
        
        private String mentor;
        
        @J2OWLProperty(name = "hasMentor", setter="setMentor")
        public String getMentor() {return mentor;}
        public void setMentor(String mentor) {this.mentor = mentor;}
        
        
    }  
    
    @J2OWLClass(EquivalentClass = "teaches some SimpleStudent")
    public static class Teacher {
        Set<SimpleStudent> students = new HashSet<SimpleStudent>();
        
        @J2OWLProperty(name = "teaches", adder="addStudent", clearer="clearStudents")
        public Set<SimpleStudent>getStudents() {return students;}
        public void addStudent(SimpleStudent student) {students.add(student);}
        public void clearStudents() {students.clear();}       
    }
    
    public static void main(String[] args) {
        args = new String[]{"build/test/classes/TestPackage/SimpleStudent.class", 
                        "exoi", "http://www.lmu.de/SimpleStudent.owl",
                        "exof", "test/TestPackage/SimpleStudent.owl",
                        "sync","true","debug","true"};
        J2OCompiler.main(args); }
}
