/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package TestPackage;

import Java2OWL.J2OCompiler;
import Java2OWL.J2OWLClass;
import Java2OWL.J2OWLProperty; 
import java.util.*;
       
/** This class is for testing accessor groups of type Map. 
 *
 * @author ohlbach     
 */
@J2OWLClass(name="Mapper",synchronise=true)              
public class TestMapper {   
    
    public String name = "";
    
    public TestMapper(){}
    
    public TestMapper(String name) {this.name =name;}
      
    // First we test functional dataProperties of type Map
    
    HashMap<Locale,String> texts = new HashMap<Locale,String>();
    
    @J2OWLProperty(name = "hasText", setter = "setTexts", adder="addText,addTextLogged", remover="removeText,removeTextLogged", 
            clearer="clearText", getKey="getKey")
    
    public HashMap<Locale,String> getTexts() {return texts;}
    
    public void setTexts(Object texts) {
        assert(texts instanceof HashMap);
        this.texts = (HashMap<Locale,String>)texts;}
    
    public String getText(Locale locale) {return texts.get(locale);}
    
    public String addText(Locale locale, String string) {return texts.put(locale,string);}
    public void addTextLogged(Locale locale, String string, boolean log) {texts.put(locale,string);if(log) System.out.println("added");}
    
    public void removeText(Locale locale) {texts.remove(locale);}
    
    public void removeTextLogged(Locale locale, boolean log) {texts.remove(locale); if(log) System.out.println("removed");}
    
    public void clearText() {texts.clear();} 
    
    public Locale getKey(String s) {return new Locale(s);}
    
    //------------------------------------------------------------------
    // Now we test relational objectProperties of type Map
    
    HashMap<String,Set<TestMapper>> friends = new HashMap<String,Set<TestMapper>>();
    
    @J2OWLProperty(name = "hasFriends", setter = "setFriends", adder="addFriends,addFriend", remover="removeFriends,removeFriend", 
            clearer="clearFriends")
    public HashMap<String,Set<TestMapper>> getFriends() {return friends;}
    
    public void setFriends(Object friends) {
        assert(friends instanceof HashMap);   
        //due to an error in BCEL 5.2, we must avoid variables of generic types.
        this.friends = (HashMap<String,Set<TestMapper>>)friends;}
    
    public Set<TestMapper> getFriends(String key) {return friends.get(key);}
    
    public void addFriends(String key, Object f1) {
        assert(f1 instanceof Set);
        friends.put(key,(Set<TestMapper>)f1);}
    
  
    public void addFriend(String key, TestMapper f) {
        if(friends.get(key) == null) {friends.put(key,new HashSet<TestMapper>());}
        friends.get(key).add(f);
    }
    
    
    public void removeFriends(String key) {friends.remove(key);}
    
    
    public void removeFriend(String key,TestMapper f) {
       Object fr = friends.get(key);
       if(fr != null) {
           ((Set<TestMapper>)fr).remove(f);
           if(((Set<TestMapper>)fr).isEmpty()) friends.remove(key);}}
    
    public void clearFriends() {friends.clear();}
    
    //------------------------------------------------------------------
    // Now we test relation data properies of type Map
    
    HashMap<String,String[]> owners = new HashMap<String,String[]>();
    
    @J2OWLProperty(name = "hasOwner", setter = "setOwners", adder="addOwner,addOwners", 
            remover="removeOwner,removeOwners", clearer="clearOwners")
    public HashMap<String,String[]> getOwners() {return owners;}
    
    public void setOwners(Object owners) {
        assert(owners instanceof Map);
        this.owners = (HashMap<String,String[]>)owners;}
    
    public void addOwner(String key, String owner) {
        String[] owns = owners.get(key);
        if(owns == null) owners.put(key,new String[]{owner});
        else {
            String[] newOwns = new String[owns.length + 1];
            for(int i = 0; i < owns.length; ++i) newOwns[i] = owns[i];
            newOwns[owns.length] = owner;
            owners.put(key,newOwns);}}
    
     public void addOwners(String key, String[] owns) {owners.put(key,owns);}
     
     public void removeOwner(String key, String owner) {
        String[] owns = owners.get(key);
        if(owns == null) return;
        int l = owns.length;
        for(int i = 0; i < l; ++i) {
            if(owns[i].equals(owner)) {
                String[] newOwns = new String[owns.length-1];
                for(int j = 0; j < i; ++j) newOwns[i] = owns[i];
                for(int j = i+1; j < l; ++j) newOwns[i] = owns[i+1];
                owners.put(key,newOwns);
                return;}}}
     
      public void removeOwners(String key) {owners.remove(key);}
      
      public void clearOwners() {owners.clear();}
    
    
    
    public static void main(String[] args) {
        args = new String[]{"build/test/classes/TestPackage/TestMapper.class", 
                        "exoi", "http://www.lmu.de/TestMapper.owl",
                        "exof", "test/TestPackage/TestMapper.owl",
                        "sync","true","debug","true"};
        J2OCompiler.main(args); }           
}
